
#include "stdafx.h"
#include "TCPClient.h"


TCPClient::TCPClient()
{
	memset( m_cbRecvBuf, 0, sizeof(m_cbRecvBuf) );
	m_nRecvSize = 0;

	// ׽
	mServerSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_IP);
	if (mServerSocket == INVALID_SOCKET)
	{
		std::cout << "׽ʧ!" << std::endl;
		return;
	}

	// IPͶ˿ں
	mServerAddr.sin_family		= AF_INET;
	mServerAddr.sin_addr.s_addr	= inet_addr(SERVER_IP);
	mServerAddr.sin_port		= htons((u_short)SERVER_PORT);

	// ӵ
	if ( ::connect(mServerSocket, (struct sockaddr*)&mServerAddr, sizeof(mServerAddr)))
	{
		::closesocket(mServerSocket);
		std::cout << "ӷʧ!" << std::endl;
		return;	
	}
}

TCPClient::~TCPClient()
{
	::closesocket(mServerSocket);
}

void TCPClient::run()
{
	int nCount = 0;
	for (;;)
	{
		// 
		int nRecvSize = ::recv(mServerSocket,
			m_cbRecvBuf+m_nRecvSize, 
			sizeof(m_cbRecvBuf)-m_nRecvSize, 0);
		if (nRecvSize <= 0)
		{
			std::cout << "Ͽ!" << std::endl;
			break;
		}

		// ѾݵĴС
		m_nRecvSize += nRecvSize;

		// յݹһͷĳ
		while (m_nRecvSize >= sizeof(NetPacketHeader))
		{
			// չ5Ͽ
			if (nCount >= 5)
			{
				::closesocket(mServerSocket);
				break;
			}

			// ȡͷ
			NetPacketHeader* pHead = (NetPacketHeader*) (m_cbRecvBuf);
			const unsigned short nPacketSize = pHead->wDataSize;

			// жǷѽյ㹻һ
			if (m_nRecvSize < nPacketSize)
			{
				// ƴճһ
				break;
			}

			// ݻ
			CopyMemory(m_cbDataBuf, m_cbRecvBuf, nPacketSize);

			// ӽջƳ
			MoveMemory(m_cbRecvBuf, m_cbRecvBuf+nPacketSize, m_nRecvSize);
			m_nRecvSize -= nPacketSize;

			// ݣʡһ
			// ...

			// ݰӦò߼
			pHead = (NetPacketHeader*) (m_cbDataBuf);
			const unsigned short nDataSize = nPacketSize - (unsigned short)sizeof(NetPacketHeader);
			OnNetMessage(pHead->wOpcode, m_cbDataBuf+sizeof(NetPacketHeader), nDataSize);

			++nCount;
		}
	}

	std::cout << "ѾͷϿ!" << std::endl;
}

bool TCPClient::OnNetMessage( const unsigned short& nOpcode, 
							 const char* pDataBuffer, unsigned short nDataSize )
{
	switch (nOpcode)
	{
	case NET_TEST1:
		{
			NetPacket_Test1* pMsg = (NetPacket_Test1*) pDataBuffer;
			return OnNetPacket(pMsg);
		}
		break;

	default:
		{
			std::cout << "ȡδ֪ݰ:" << nOpcode << std::endl;
			return false;
		}
		break;
	}
}

bool TCPClient::OnNetPacket( NetPacket_Test1* pMsg )
{
	std::cout << "" << pMsg->nIndex << "  ַ" << pMsg->arrMessage << std::endl;
	return true;
}
